Index: LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2298)
@@ -10,5 +10,6 @@
   USE surface_data,     ONLY : type_ocean, version_ocean
   USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, dtime, &
-       du_gwd_rando, dv_gwd_rando, entr_therm, f0, falb1, falb2, fm_therm, &
+       qsol, fevap, z0m, z0h, agesno, &
+       du_gwd_rando, dv_gwd_rando, entr_therm, f0, fm_therm, &
        falb_dir, falb_dif, &
        ftsol, pbl_tke, pctsrf, q_ancien, radpas, radsol, rain_fall, ratqs, &
@@ -20,5 +21,5 @@
        zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl
   USE iostart, ONLY : close_startphy, get_field, get_var, open_startphy
-  USE infotrac, only: nbtr, type_trac, tname, niadv
+  USE infotrac, only: nbtr, nqo, type_trac, tname, niadv
   USE traclmdz_mod,    ONLY : traclmdz_from_restart
   USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl, co2_send
@@ -46,10 +47,6 @@
   REAL tsoil(klon, nsoilmx, nbsrf)
   REAL qsurf(klon, nbsrf)
-  REAL qsol(klon)
   REAL snow(klon, nbsrf)
-  REAL evap(klon, nbsrf)
   real fder(klon)
-  REAL frugs(klon, nbsrf)
-  REAL agesno(klon, nbsrf)
   REAL run_off_lic_0(klon)
   REAL fractint(klon)
@@ -74,5 +71,5 @@
   CHARACTER*7 str7
   CHARACTER*2 str2
-  LOGICAL :: found
+  LOGICAL :: found,phyetat0_get,phyetat0_srf
 
   ! FH1D
@@ -205,353 +202,71 @@
   END DO
 
-  ! Lecture des temperatures du sol:
-
-  CALL get_field("TS", ftsol(:, 1), found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <TS> est absent'
-     PRINT*, '          Mais je vais essayer de lire TS**'
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
+!===================================================================
+! Lecture des temperatures du sol:
+!===================================================================
+
+  found=phyetat0_get(1,ftsol(:,1),"TS","Surface temperature",283.)
+  IF (found) THEN
+     DO nsrf=2,nbsrf
+        ftsol(:,nsrf)=ftsol(:,1)
+     ENDDO
+  ELSE
+     found=phyetat0_srf(1,ftsol,"TS","Surface temperature",283.)
+  ENDIF
+
+!===================================================================
+  ! Lecture des albedo difus et direct
+!===================================================================
+
+  DO nsrf = 1, nbsrf
+     DO isw=1, nsw
+        IF (isw.GT.99) THEN
+           PRINT*, "Trop de bandes SW"
            call abort_gcm("phyetat0", "", 1)
         ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field("TS"//str2, ftsol(:, nsrf))
-
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon
-           xmin = MIN(ftsol(i, nsrf), xmin)
-           xmax = MAX(ftsol(i, nsrf), xmax)
-        ENDDO
-        PRINT*, 'Temperature du sol TS**:', nsrf, xmin, xmax
+        WRITE(str2, '(i2.2)') isw
+        found=phyetat0_srf(1,falb_dir(:, isw,:),"A_dir_SW"//str2//"srf","Direct Albedo",0.2)
+        found=phyetat0_srf(1,falb_dif(:, isw,:),"A_dif_SW"//str2//"srf","Direct Albedo",0.2)
      ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <TS> est present'
-     PRINT*, '          J ignore donc les autres temperatures TS**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(ftsol(i, 1), xmin)
-        xmax = MAX(ftsol(i, 1), xmax)
-     ENDDO
-     PRINT*, 'Temperature du sol <TS>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           ftsol(i, nsrf) = ftsol(i, 1)
-        ENDDO
-     ENDDO
-  ENDIF
-
-!===================================================================
-  ! Lecture des albedo difus et direct
-
-  DO nsrf = 1, nbsrf
-     DO isw=1, nsw
-        IF (isw.GT.99 .AND. nsrf.GT.99) THEN
-           PRINT*, "Trop de bandes SW ou sous-mailles"
+  ENDDO
+
+!===================================================================
+  ! Lecture des temperatures du sol profond:
+!===================================================================
+
+   DO isoil=1, nsoilmx
+        IF (isoil.GT.99) THEN
+           PRINT*, "Trop de couches "
            call abort_gcm("phyetat0", "", 1)
         ENDIF
-        WRITE(str7, '(i2.2, "srf", i2.2)') isw, nsrf
-
-        CALL get_field('A_dir_SW'//str7, falb_dir(:, isw, nsrf), found)
-        IF (.NOT. found) THEN
-           PRINT*, "phyetat0: Le champ <A_dir_SW"//str7//"> est absent"
-           PRINT*, "          Il prend donc la valeur de surface"
-           DO i=1, klon
-              falb_dir(i, isw, nsrf)=0.2
-           ENDDO
-        ENDIF
-        CALL get_field('A_dif_SW'//str7, falb_dif(:, isw, nsrf), found)
-        IF (.NOT. found) THEN
-           PRINT*, "phyetat0: Le champ <A_dif_SW"//str7//"> est absent"
-           PRINT*, "          Il prend donc la valeur de surface"
-           DO i=1, klon
-              falb_dif(i, isw, nsrf)=0.2
-           ENDDO
-        ENDIF
-     ENDDO
-  ENDDO
-
-!===================================================================
-  ! Lecture des temperatures du sol profond:
-
-  DO nsrf = 1, nbsrf
-     DO isoil=1, nsoilmx
-        IF (isoil.GT.99 .AND. nsrf.GT.99) THEN
-           PRINT*, "Trop de couches ou sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str7, '(i2.2, "srf", i2.2)') isoil, nsrf
-
-        CALL get_field('Tsoil'//str7, tsoil(:, isoil, nsrf), found)
+        WRITE(str2,'(i2.2)') isoil
+        found=phyetat0_srf(1,tsoil(:, isoil,:),"Tsoil"//str2//"srf","Temp soil",0.)
         IF (.NOT. found) THEN
            PRINT*, "phyetat0: Le champ <Tsoil"//str7//"> est absent"
            PRINT*, "          Il prend donc la valeur de surface"
-           DO i=1, klon
-              tsoil(i, isoil, nsrf)=ftsol(i, nsrf)
-           ENDDO
+           tsoil(:, isoil, :)=ftsol(:, :)
         ENDIF
-     ENDDO
-  ENDDO
-
-!===================================================================
-  ! Lecture de l'humidite de l'air juste au dessus du sol:
-
-  CALL get_field("QS", qsurf(:, 1), found)
+   ENDDO
+
+!=======================================================================
+! Lecture precipitation/evaporation
+!=======================================================================
+
+  found=phyetat0_srf(1,qsurf,"QS","Near surface hmidity",0.)
+  found=phyetat0_get(1,qsol,"QSOL","Surface hmidity / bucket",0.)
+  found=phyetat0_srf(1,snow,"SNOW","Surface snow",0.)
+  found=phyetat0_srf(1,fevap,"EVAP","evaporation",0.)
+  found=phyetat0_get(1,snow_fall,"snow_f","snow fall",0.)
+  found=phyetat0_get(1,rain_fall,"rain_f","rain fall",0.)
+
+!=======================================================================
+! Radiation
+!=======================================================================
+
+  found=phyetat0_get(1,solsw,"solsw","net SW radiation surf",0.)
+  found=phyetat0_get(1,sollw,"sollw","net LW radiation surf",0.)
+  found=phyetat0_get(1,sollwdown,"sollwdown","down LW radiation surf",0.)
   IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <QS> est absent'
-     PRINT*, '          Mais je vais essayer de lire QS**'
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field("QS"//str2, qsurf(:, nsrf))
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon
-           xmin = MIN(qsurf(i, nsrf), xmin)
-           xmax = MAX(qsurf(i, nsrf), xmax)
-        ENDDO
-        PRINT*, 'Humidite pres du sol QS**:', nsrf, xmin, xmax
-     ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <QS> est present'
-     PRINT*, '          J ignore donc les autres humidites QS**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(qsurf(i, 1), xmin)
-        xmax = MAX(qsurf(i, 1), xmax)
-     ENDDO
-     PRINT*, 'Humidite pres du sol <QS>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           qsurf(i, nsrf) = qsurf(i, 1)
-        ENDDO
-     ENDDO
-  ENDIF
-
-  ! Eau dans le sol (pour le modele de sol "bucket")
-
-  CALL get_field("QSOL", qsol, found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <QSOL> est absent'
-     PRINT*, '          Valeur par defaut nulle'
-     qsol(:)=0.
-  ENDIF
-
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(qsol(i), xmin)
-     xmax = MAX(qsol(i), xmax)
-  ENDDO
-  PRINT*, 'Eau dans le sol (mm) <QSOL>', xmin, xmax
-
-  ! Lecture de neige au sol:
-
-  CALL get_field("SNOW", snow(:, 1), found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <SNOW> est absent'
-     PRINT*, '          Mais je vais essayer de lire SNOW**'
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field( "SNOW"//str2, snow(:, nsrf))
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon
-           xmin = MIN(snow(i, nsrf), xmin)
-           xmax = MAX(snow(i, nsrf), xmax)
-        ENDDO
-        PRINT*, 'Neige du sol SNOW**:', nsrf, xmin, xmax
-     ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <SNOW> est present'
-     PRINT*, '          J ignore donc les autres neiges SNOW**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(snow(i, 1), xmin)
-        xmax = MAX(snow(i, 1), xmax)
-     ENDDO
-     PRINT*, 'Neige du sol <SNOW>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           snow(i, nsrf) = snow(i, 1)
-        ENDDO
-     ENDDO
-  ENDIF
-
-  ! Lecture de albedo de l'interval visible au sol:
-
-  CALL get_field("ALBE", falb1(:, 1), found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <ALBE> est absent'
-     PRINT*, '          Mais je vais essayer de lire ALBE**'
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field("ALBE"//str2, falb1(:, nsrf))
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon
-           xmin = MIN(falb1(i, nsrf), xmin)
-           xmax = MAX(falb1(i, nsrf), xmax)
-        ENDDO
-        PRINT*, 'Albedo du sol ALBE**:', nsrf, xmin, xmax
-     ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <ALBE> est present'
-     PRINT*, '          J ignore donc les autres ALBE**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(falb1(i, 1), xmin)
-        xmax = MAX(falb1(i, 1), xmax)
-     ENDDO
-     PRINT*, 'Neige du sol <ALBE>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           falb1(i, nsrf) = falb1(i, 1)
-        ENDDO
-     ENDDO
-  ENDIF
-
-  ! Lecture de albedo au sol dans l'interval proche infra-rouge:
-
-  CALL get_field("ALBLW", falb2(:, 1), found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <ALBLW> est absent'
-     PRINT*, '          Mais je vais prendre ALBE**'
-     DO nsrf = 1, nbsrf
-        DO i = 1, klon
-           falb2(i, nsrf) = falb1(i, nsrf)
-        ENDDO
-     ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <ALBLW> est present'
-     PRINT*, '          J ignore donc les autres ALBLW**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(falb2(i, 1), xmin)
-        xmax = MAX(falb2(i, 1), xmax)
-     ENDDO
-     PRINT*, 'Neige du sol <ALBLW>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           falb2(i, nsrf) = falb2(i, 1)
-        ENDDO
-     ENDDO
-  ENDIF
-
-  ! Lecture de evaporation:  
-
-  CALL get_field("EVAP", evap(:, 1), found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <EVAP> est absent'
-     PRINT*, '          Mais je vais essayer de lire EVAP**'
-     DO nsrf = 1, nbsrf
-        IF (nsrf.GT.99) THEN
-           PRINT*, "Trop de sous-mailles"
-           call abort_gcm("phyetat0", "", 1)
-        ENDIF
-        WRITE(str2, '(i2.2)') nsrf
-        CALL get_field("EVAP"//str2, evap(:, nsrf))
-        xmin = 1.0E+20
-        xmax = -1.0E+20
-        DO i = 1, klon
-           xmin = MIN(evap(i, nsrf), xmin)
-           xmax = MAX(evap(i, nsrf), xmax)
-        ENDDO
-        PRINT*, 'evap du sol EVAP**:', nsrf, xmin, xmax
-     ENDDO
-  ELSE
-     PRINT*, 'phyetat0: Le champ <EVAP> est present'
-     PRINT*, '          J ignore donc les autres EVAP**'
-     xmin = 1.0E+20
-     xmax = -1.0E+20
-     DO i = 1, klon
-        xmin = MIN(evap(i, 1), xmin)
-        xmax = MAX(evap(i, 1), xmax)
-     ENDDO
-     PRINT*, 'Evap du sol <EVAP>', xmin, xmax
-     DO nsrf = 2, nbsrf
-        DO i = 1, klon
-           evap(i, nsrf) = evap(i, 1)
-        ENDDO
-     ENDDO
-  ENDIF
-
-  ! Lecture precipitation liquide:
-
-  CALL get_field("rain_f", rain_fall)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(rain_fall(i), xmin)
-     xmax = MAX(rain_fall(i), xmax)
-  ENDDO
-  PRINT*, 'Precipitation liquide rain_f:', xmin, xmax
-
-  ! Lecture precipitation solide:
-
-  CALL get_field("snow_f", snow_fall)
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(snow_fall(i), xmin)
-     xmax = MAX(snow_fall(i), xmax)
-  ENDDO
-  PRINT*, 'Precipitation solide snow_f:', xmin, xmax
-
-  ! Lecture rayonnement solaire au sol:
-
-  CALL get_field("solsw", solsw, found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <solsw> est absent'
-     PRINT*, 'mis a zero'
-     solsw(:) = 0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(solsw(i), xmin)
-     xmax = MAX(solsw(i), xmax)
-  ENDDO
-  PRINT*, 'Rayonnement solaire au sol solsw:', xmin, xmax
-
-  ! Lecture rayonnement IF au sol:
-
-  CALL get_field("sollw", sollw, found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <sollw> est absent'
-     PRINT*, 'mis a zero'
-     sollw = 0.
-  ENDIF
-  xmin = 1.0E+20
-  xmax = -1.0E+20
-  DO i = 1, klon
-     xmin = MIN(sollw(i), xmin)
-     xmax = MAX(sollw(i), xmax)
-  ENDDO
-  PRINT*, 'Rayonnement IF au sol sollw:', xmin, xmax
-
-  CALL get_field("sollwdown", sollwdown, found)
-  IF (.NOT. found) THEN
-     PRINT*, 'phyetat0: Le champ <sollwdown> est absent'
-     PRINT*, 'mis a zero'
-     sollwdown = 0.
-     zts=0.
+     sollwdown = 0. ;  zts=0.
      do nsrf=1,nbsrf
         zts(:)=zts(:)+ftsol(:,nsrf)*pctsrf(:,nsrf)
